
Website Input - Feature #1149

Interactively allow creation of selector

01/14/2016 05:42 AM - Luke Murphey

Status: Closed Start date: 01/15/2016

Priority: Urgent Due date:  

Assignee: Luke Murphey % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

Description

Add the ability to interactively create a selector from the UI.

This can be done with something like the SelectorGadget (http://selectorgadget.com/). It could work like this:

1. Have a link to open the defined web-page with the selector gadget loaded and the selector set accordingly

2. If a URL is not yet defined, then just show a warning

3. Add in a dialog that tells the user that the red box is for removing matches

Subtasks:

Task # 1150: Include selector gadget Closed

Task # 1151: Wire up hook to set URL in selector window Rejected

Task # 1152: Wire up hook to get selector from selector window Rejected

Task # 1153: Wire up hook to set selector in selector window Rejected

Task # 1154: Wire up close button to close selector window Rejected

Task # 1155: Improve loading screen Closed

Task # 1156: Remove xpath dialog Rejected

Task # 1157: Improve instructions Closed

History

#1 - 01/14/2016 05:48 AM - Luke Murphey

http://blog.caplin.com/2013/02/26/superselector-a-javascript-gui-tool-to-generate-css-selectors/

https://github.com/cantino/selectorgadget

https://flutter.social/bookmarklet

#2 - 01/14/2016 05:55 AM - Luke Murphey

If using selector gadget, changes include:

Nicer loading screen

Guidance that you should click red boxes to limit matches

Callback so that selector info is sent back to input page

Close button should close the page too

Needs to support setting the selector externally

Remove xpath option

Might want to disable links (or obtain link from page if it changes)

#3 - 02/07/2016 03:42 AM - Luke Murphey

Turns out that you can't do this. The browser won't allow it unless they are on the same domain (https://github.com/cantino/selectorgadget/pull/4).
#4 - 02/08/2016 06:56 PM - Luke Murphey

Could include this as a bookmarklet.

#5 - 05/27/2016 02:01 AM - Luke Murphey

I might be able to make this happen by making a proxy within Splunk. I could use rewrite_links() within lxml to re-write the links (

http://stackoverflow.com/questions/5789127/how-to-replace-links-using-lxml-and-iterlinks).

#6 - 09/21/2016 07:01 AM - Luke Murphey

To try the proxy, I would need:

1. To write a simple Python proxy within Splunk (authentication would need to be required)

2. Re-write the URLs accordingly

3. Put restrictions on the proxy requests (authenticated user, would need the ability to create a web_input, size limitation)

#7 - 11/11/2016 01:24 AM - Luke Murphey

Some thoughts:

Might want to block following links in the iframe

Allowing following the links using the internal proxy (and updating the URL accordingly)

#8 - 11/11/2016 06:12 AM - Luke Murphey

https://github.com/cantino/selectorgadget

#9 - 11/11/2016 07:34 AM - Luke Murphey

The DomPredictionHelper is what is used to make the CSS selector. See 

https://github.com/cantino/selectorgadget/blob/master/spec/test_sites/test/testDom.html.

https://www.reddit.com/r/webdev/comments/1xh1g6/does_there_exist_a_dom_navigator_that_calculates/

var Predict = new DomPredictionHelper();

$(document.body).on('click', function (e) {

    var elem = document.elementFromPoint(e.clientX, e.clientY);

    alert(Predict.getPathsFor([elem]));

});

#10 - 11/11/2016 08:16 PM - Luke Murphey

Some things I don't like about the current approach:

There may be a race condition when applying the JS to the iframe

The code for loading the css and JS in the iframe is ugly. Use something like the addStylesheet() function in Slideshow (

http://lukemurphey.net/projects/splunk-slideshow/repository/entry/trunk/src/appserver/static/js/views/SlideshowSetupView.js).
#11 - 11/18/2016 04:34 AM - Luke Murphey

- Status changed from New to Closed
